import { Rule, SubjectType } from './types';
export declare class Ability {
    private readonly rules;
    constructor(rules?: Rule[]);
    can(action: string, subject: SubjectType, context?: Record<string, any>): boolean;
    cannot(action: string, subject: SubjectType, context?: Record<string, any>): boolean;
    mustCan(action: string, subject: SubjectType, context?: Record<string, any>): void;
    mustCannot(action: string, subject: SubjectType, context?: Record<string, any>): void;
    exportRules(): string;
    static importRules(json: string): Ability;
    private check;
    private _matchConditions;
    private _getSubjectName;
    private _matchSubject;
    private _describeSubject;
}
