"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AbilityBuilder = void 0;
const ability_1 = require("./ability");
class AbilityBuilder {
    constructor() {
        this.rules = [];
    }
    can(actions, subjects, conditions) {
        this._addRule(actions, subjects, conditions, false);
        return this;
    }
    cannot(actions, subjects, conditions) {
        this._addRule(actions, subjects, conditions, true);
        return this;
    }
    build() {
        return new ability_1.Ability(this.rules);
    }
    _addRule(actions, subjects, conditions, inverted) {
        const actionsArr = Array.isArray(actions) ? actions : [actions];
        const subjectsArr = Array.isArray(subjects) ? subjects : [subjects];
        this.rules.push({ actions: actionsArr, subjects: subjectsArr, conditions, inverted });
    }
}
exports.AbilityBuilder = AbilityBuilder;
